#ifndef __ARCH_IA32_KEYBOARD__
#define __ARCH_IA32_KEYBOARD__

#define KB_LED_SCR	0x01
#define KB_LED_NUM	0x02
#define KB_LED_CAP	0x04

enum {
	KB_MOD_SHIFT,
	KB_MOD_CAPS,
	KB_MOD_ALT,
	KB_MOD_CTRL
}kb_modifiers;

typedef struct _kb_scan{
	u_int8_t	scan;
	u_int8_t	ascii;
	u_int8_t	shift;
}kb_scan_t;

/* Driver functions */
void keyboard_init(void);
u_int32_t keyboard_probe(void);
u_int32_t keyboard_setup(void);

/* Other functions */
void kb_setleds(void);
void kb_led_on(u_int8_t);
void kb_led_off(u_int8_t);
u_int8_t kb_readkey(void);
u_int32_t kb_keypress(void);

#endif /* __ARCH_IA32_KEYBOARD__ */
