/* Copyright (c) 2001 Greg Sheard <greg@ecsc.co.uk>*/
#ifndef __PCI_H_INCLUDED__
#define __PCI_H_INCLUDED__

void pci_init(void);
u_int32_t pci_probe(void);
u_int32_t pci_probe_direct(void);
u_int32_t pci_setup(void);
u_int32_t pci_init_bus(u_int32_t);
u_int32_t pci_halt_bus(u_int32_t);
u_int32_t pci_setup_identify(u_int32_t);
u_int32_t pci_setup_getdev(u_int32_t);
char *pf(u_int32_t);

typedef struct pci_device {
	char		*name;
	u_int32_t	device;
	u_int32_t	flags;
}pci_device_t, *p_pci_device;

typedef struct pci_vendor {
	char		*name;
	u_int32_t	vendor;
	pci_device_t	devlist[128];
}pci_vendor_t, *p_pci_vendor;

/* PCI device flags */
#define PCI_FLAGS_BRIDGE	0x0001
#define PCI_FLAGS_BRIDGE_HOST	0x0002
#define PCI_FLAGS_BRIDGE_AGP	0x0004
#define PCI_FLAGS_BRIDGE_ISA	0x0008
#define PCI_FLAGS_BRIDGE_PCI	0x000F

#define PCI_FLAGS_DEVICE_PCI	0x0010
#define PCI_FLAGS_DEVICE_ISA	0x0020
#define PCI_FLAGS_DEVICE_AGP	0x0040
#define PCI_FLAGS_DEVICE_OTHER	0x00F0

#define PCI_FLAGS_TYPE_ETHER	0x0100
#define PCI_FLAGS_TYPE_VGA	0x0200
#define PCI_FLAGS_TYPE_COMMS	0x0400
#define PCI_FLAGS_TYPE_USB	0x0800
#define PCI_FLAGS_TYPE_IDE	0x0F00

/* PCI device vendors (retained for non-existent codes)*/
#define PCI_VENDOR_ANY		0x0000
#define PCI_VENDOR_NODEVICE	0xFFFF

/* PCI device IDs (retained for non-existent codes)*/
#define PCI_DEVCODE_ANY		0x0000
#define PCI_DEVCODE_NODEVICE	0xFFFF

#endif /* __PCI_H_INCLUDED__ */
