#include <types.h>
#include <lib/ksym.h>
#include <arch/io.h>

EXPORT_SYMBOL(inb);
EXPORT_SYMBOL(inl);
EXPORT_SYMBOL(outb);
EXPORT_SYMBOL(outw);
EXPORT_SYMBOL(outl);
EXPORT_SYMBOL(inb_p);
EXPORT_SYMBOL(outb_p);
EXPORT_SYMBOL(outw_p);

u_int8_t  inb (u_int32_t port)
{
	u_int8_t ret;
	asm volatile ("inb %%dx,%%al":"=a" (ret):"d" (port));
	return ret;
}

u_int32_t  inl (u_int32_t port)
{
	u_int32_t ret;
	asm volatile ("inl %%dx,%%eax":"=a"(ret):"d" (port));
	return ret;
}

void  outb (u_int32_t port, u_int8_t val)
{
	asm volatile ("outb %%al,%%dx"::"d" (port), "a" (val));
}

void  outw (u_int32_t port, u_int16_t val)
{
	asm volatile ("outw %%ax,%%dx"::"d" (port), "a" (val));
}

void  outl (u_int32_t port, u_int32_t val)
{
	asm volatile ("outl %%eax,%%dx"::"d" (port), "a" (val));
}

u_int8_t  inb_p (u_int32_t port)
{
	u_int8_t ret;
	asm volatile ("inb %%dx,%%al;outb %%al,$0x80":"=a" (ret):"d" (port));
	return ret;
}

void  outb_p (u_int32_t port, u_int8_t val)
{
   asm volatile ("outb %%al,%%dx;outb %%al,$0x80"::"d" (port), "a" (val));
}

void  outw_p (u_int32_t port, u_int16_t val)
{
	asm volatile ("outw %%ax,%%dx;outb %%al,$0x80"::"d" (port), "a" (val));
}

