#define __ASM__	1
#include <arch/multiboot.h>
.text
.globl	start, _start
start:
_start:
	cli
	jmp	multiboot_entry

	/* Align 32 bits boundary.  */
	.align	4
	
	/* Multiboot header.  */
multiboot_header:
	/* magic */
	.long	MULTIBOOT_HEADER_MAGIC
	/* flags */
	.long	MULTIBOOT_HEADER_FLAGS
	/* checksum */
	.long	-(MULTIBOOT_HEADER_MAGIC + MULTIBOOT_HEADER_FLAGS)
#ifndef __ELF__
	/* header_addr */
	.long	multiboot_header
	/* load_addr */
	.long	_start
	/* load_end_addr */
	.long	_edata
	/* bss_end_addr */
	.long	_end
	/* entry_addr */
	.long	multiboot_entry
#endif /* ! __ELF__ */

multiboot_entry:
	#; Initialise SP
	movl	$(stack + STACK_SIZE), %esp

	#; Reset EFLAGS
	pushl	$0
	popf

	#; Enter the arch kernel
	pushl	%ebx	#; mbi structure
	pushl	%eax	#; magic
	call	EXT_C(multiboot_init)

	#; Print halt message
	pushl	$halt_message
	call	EXT_C(kprint)
	
#; Halt
	cli
loop:	hlt
	jmp	loop

halt_message:
	.asciz	"System Halted."
	.comm	stack, STACK_SIZE
