#ifndef __LIB_KSYM__
#define __LIB_KSYM__
#include <types.h>

/* A symtab entry :
* The char ptr points to a readonly char in the 
* kstrtab section */
typedef struct ksym {
	u_int32_t	value;
	const char	*name;
}ksym_t, *p_ksym;

void ksym_list(void);
u_int32_t ksym_resolve(const char *);

/* Handy wrapper for __EXPORT_SYMBOL */
#define EXPORT_SYMBOL(sym) \
	__EXPORT_SYMBOL(sym, #sym)

/* This macro sets up the kernel string and the table entry */
#define __EXPORT_SYMBOL(sym, str) 			\
const char __kstrtab_##sym[]				\
__attribute__((section(".kstrtab"))) = str;		\
const ksym_t __ksymtab_##sym				\
__attribute__((section("__ksymtab"))) = 		\
{ (u_int32_t)&sym, __kstrtab_##sym }

#endif /* __LIB_KSYM__ */
